
/******************************************************************************
* MODULE     : timer.cpp
* DESCRIPTION: timers
* COPYRIGHT  : (C) 1999  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "base.hpp"

namespace mml {

#ifdef OS_SUN
#include <sys/types.h>
#endif

#ifdef USE_GET_TIME_OF_DAY
#include <sys/time.h>
#else
#include <sys/timeb.h>
#ifdef OS_SUN
extern "C" {
  extern int ftime __P ((struct timeb *__timebuf));
};
#endif
#endif

nat
mml_time () {
#ifdef USE_GET_TIME_OF_DAY
  struct timeval tp;
  gettimeofday (&tp, NULL);
  return (nat) ((time_t) ((tp.tv_sec * 1000) + (tp.tv_usec / 1000)));
#else
  timeb tb;
  ftime (&tb);
  return (nat) ((time_t) ((tb.time * 1000) + tb.millitm));
#endif
}

} // namespace mml
