
/******************************************************************************
* MODULE     : string_int.cpp
* DESCRIPTION: Strings from ints
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "string.hpp"
namespace mml {

static void
print_int (string& s, int i) {
  if (i<10) s << ((char) (((int) '0') + i));
  else {
    print_int (s, i/10);
    s << ((char) (((int) '0') + (i%10)));
  }
}

string
as_string (int i) {
  string s ("");
  if (i < 0) { s << "-"; i=-i; }
  print_int (s, i);
  return s;
}

} // namespace mml
