/******************************************************************************
* MODULE     : pivot_test.cc
* DESCRIPTION: Test matrices
* COPYRIGHT  : (C) 2004  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "integer.hpp"
#include "real.hpp"
#include "dense_pivot.hpp"
using namespace mml;

int
main() {

  integer* o= new integer[400];
  integer* t= o;
  for (nat i = 0; i < 400; i++) {
    *t = integer (i+1);
    t++;
  }
  matrix<integer> O (o, 20, 20);
  cout << "O =\n" << O << "\n";
  gauss_pivoting(O, 0, 0, 19, 19);
  cout << "O =\n" << O << "\n";
  

  integer* m= new integer[400];
  integer* n= m;
  for (nat i = 0; i < 400; i++) {
    *n = integer (i+1);
    n++;
  }
  matrix<integer> M (m,20,20) ;
  cout << "M = \n"<< M << "\n";
  facto_gauss_pivoting(M,0,0,19,19);
  cout << "M = \n"<< M << "\n";

  integer* a= new integer[400];
  integer* b= a;
  for (nat i = 0; i < 400; i++) {
    *b = integer (i+1);
    b++;
  }
  matrix<integer> A (a,20,20) ;
  cout << "rank 2 -> " << rank(A) <<"\n"; 

  return 0;
}

