
/******************************************************************************
* MODULE     : fft_test.cpp
* DESCRIPTION: Test FFT
* COPYRIGHT  : (C) 2005  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "fft.hpp"
using namespace mml;

typedef modular<FFTP> K;

template<typename C> C*
make (nat n) {
  C* a= new C[n];
  for (nat i=0; i<n; i++)
    a[i]= i*i;
  return a;
}

int
main () {
  /*
  K* a= make<K> (256);
  print (a, 16);
  fft (a, 8, 32, false);
  print (a, 16);
  fft (a, 8, 32, true);
  print (a, 16);
  delete[] a;
  */
  K* a= make<K> (16);
  print (a, 16);
  fft (a, 16, false);
  print (a, 16);
  fft (a, 16, true);
  print (a, 16);
  delete[] a;
  return 0;
}
