
/******************************************************************************
* MODULE     : tft_test.cpp
* DESCRIPTION: Test TFT
* COPYRIGHT  : (C) 2005  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "tft.hpp"
using namespace mml;

typedef modular<FFTP> K;

template<typename C> C*
make (nat n) {
  C* a= new C[n];
  for (nat i=0; i<n; i++)
    a[i]= 0;
  return a;
}

template<typename C> C*
make_test () {
  C* a= make<C> (16);
  for (nat i=0; i<11; i++)
    a[i]= (i+1)*(i+1);
  a[6]= 0;
  a[7]= 0;
  return a;
}

int
main () {
  K* a= make_test<K> ();
  print (a, 16); cout << "\n";
  tft_tree<K> t= tft_segment (a, 16);
  print (t); cout << "\n";
  fft (a, 16, false);
  print (a, 16); cout << "\n";  
  tft (t);
  print (t); cout << "\n";
  delete[] a;
  return 0;
}
